.\" Copyright (c) 1993 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/sbin/modload/modload.8,v 1.7.2.3 1999/09/05 11:24:02 peter Exp $
.\"
.Dd September 22, 1994
.Dt MODLOAD 8
.Os
.Sh NAME
.Nm modload
.Nd load a kernel module
.Sh SYNOPSIS
.Nm modload
.Op Fl dquv
.Op Fl A Ar kernel
.Op Fl e Ar entry
.Op Fl p Ar postinstall
.Op Fl o Ar output_file
.Ar input_file
.Sh DESCRIPTION
The
.Nm
utility loads a loadable kernel module into a running system.
The input file is an object file (.o file).
.Pp
The options to
.Nm
are as follows:
.Bl -tag -width indent
.It Fl d
Debug.  Used to debug
.Nm
itself.
.It Fl q
Be very quiet.
.It Fl u
Delete the loaded module
.Pq Ar output_file
after loading.  If the output file was not specified, this option causes the
temporary file to be kept rather than deleted.
.It Fl v
Print comments about the loading process.
.It Fl A Ar kernel
Specify the file that is passed to the linker
to resolve module references to external symbols. 
The symbol file must be for the currently running
kernel or the module is likely to crash the system.
.It Fl e Ar entry
Specify the module entry point.
This is passed by
.Nm
to
.Xr ld 1
when the module is linked.
The default module entry point name is the module name with `_mod' appended.
.It Fl p Ar postinstall
Specify the name of a shell script or program that will
be executed if the module is successfully loaded. It
is always passed the module id (in decimal) and module
type (in hexadecimal) as the first two arguments.
For loadable drivers, the third argument is
the block or character major device number.
For a loadable system call, the third argument is the system
call number.
.It Fl o Ar output_file
Specify the name of the output file that is produced by
the linker.  If this option is not specified, a file in the /tmp directory
is used with the name generated from the module name with a `.out' extension.
.El
.Sh FILES
.Bl -tag -width /usr/include/sys/lkm.h -compact
.It Pa /kernel
default file passed to the linker to resolve external
references in the module
.It Pa /usr/include/sys/lkm.h
file containing definitions of module types
.\" .It Pa output file.
.\" default output file name
.Sh DIAGNOSTICS
The
.Nm
utility exits with a status of 0 on success
and with a nonzero status if an error occurs.
.Sh SEE ALSO
.Xr ld 1 ,
.Xr lkm 4 ,
.Xr modstat 8 ,
.Xr modunload 8
.Sh HISTORY
The
.Nm
command was designed to be similar in functionality
to the corresponding command in
.Tn "SunOS 4.1.3" .
.Sh AUTHORS
.An Terrence R. Lambert Aq terry@cs.weber.edu
.Sh BUGS
The loadable device driver framework can
only reserve either a character or block device entry, not both.
